# -*- coding: utf-8 -*-
from Components.Converter.Converter import Converter
from enigma import iServiceInformation, iPlayableService, iPlayableServicePtr
from Components.Element import cached
from enigma import eTimer

class ConditionalLcdDigital(Converter, object):
	def __init__(self, type):
		Converter.__init__(self, "")
		tagnames,min = type.split(":")
		self.min = min
		self.tags = tagnames.split(",")
		self.tag = self.tags[0]
		self.count = 0
		
	def blinkFunc(self):
		self.count = (self.count + 1) % len(self.tags)
		self.tag = self.tags[self.count]
		self.changed((self.CHANGED_POLL,))

	def connectDownstream(self, downstream):
		Converter.connectDownstream(self, downstream)
		if (len(self.tags) > 1):
			self.blinktime = int(self.min)  * 1000
			self.timer = eTimer()
			self.connect = self.timer.timeout.connect(self.blinkFunc)
			self.timer.start(self.blinktime)

	def destroy(self):
		self.connect = None
		
	@cached
	def getTag(self):
		return self.tag

	LcdDigitalTag = property(getTag)
