# -*- coding: utf-8 -*-
from Components.Converter.Converter import Converter
from enigma import iServiceInformation, iPlayableService, iPlayableServicePtr
from Components.Element import cached
from Plugins.Extensions.LcdDigital.xmltools import *
from Components.config import config

class ServiceNameLcdDigital(Converter, object):
	NAME = 0
	PROVIDER = 1
	REFERENCE = 2
	NAME_REFERENCE = 3

	def __init__(self, type):
		Converter.__init__(self, type)
		if type == "Provider":
			self.type = self.PROVIDER
		elif type == "Reference":
			self.type = self.REFERENCE
		elif type == "NameReference":
			self.type = self.NAME_REFERENCE
		else:
			self.type = self.NAME

#	def getServiceInfoValue(self, info, what, ref=None):
#		v = ref and info.getInfo(ref, what) or info.getInfo(what)
#		if v != iServiceInformation.resIsString:
#			return "N/A"
#		return ref and info.getInfoString(ref, what) or info.getInfoString(what)

	def getServiceInfoValue(self, info, what, ref=None):
		v = ref and info.getInfo(ref, what) or info.getInfo(what)
		if v != iServiceInformation.resIsString:
			ret = "N/A" if not ref or self.type != self.REFERENCE else ref.toString()
		elif ref:
			ret = info.getInfoString(ref, what) or self.type == self.REFERENCE and ref.toString()
		else:
			ret = info.getInfoString(what)
		if ret:
			pass
		else:
			ret = "N/A"
		return ret

	@cached
	def getText(self):
		service = self.source.service
		if isinstance(service, iPlayableServicePtr):
			info = service and service.info()
			ref = None
		else: # reference
			info = service and self.source.info
			ref = service
		if info is None:
			return ""
		if self.type == self.NAME:
			name = ref and info.getName(ref)
			if name is None:
				name = info.getName()
			return name.replace('\xc2\x86', '').replace('\xc2\x87', '')
		elif self.type == self.NAME_REFERENCE:
			name = ref and info.getName(ref)
			if name is None:
				name = info.getName()
			erg = ""
			if self.getServiceInfoValue(info, iServiceInformation.sServiceref, ref) == "N/A":
				try:
					lname = name.replace('\xc2\x86', '').replace('\xc2\x87', '')
					erg = lname + '|' + LcdDigital.ServiceList[lname]
				except KeyError:
					erg = name.replace('\xc2\x86', '').replace('\xc2\x87', '') + '|' + self.getServiceInfoValue(info, iServiceInformation.sServiceref, ref)
			else:
				erg = name.replace('\xc2\x86', '').replace('\xc2\x87', '') + '|' + self.getServiceInfoValue(info, iServiceInformation.sServiceref, ref)
			print "Channel: " + erg
			a = 2
#			b = a / 0
			return erg
		elif self.type == self.PROVIDER:
			return self.getServiceInfoValue(info, iServiceInformation.sProvider, ref)
		elif self.type == self.REFERENCE:
			return self.getServiceInfoValue(info, iServiceInformation.sServiceref, ref)

	text = property(getText)

	def changed(self, what):
		if what[0] != self.CHANGED_SPECIFIC or what[1] in (iPlayableService.evStart,):
			Converter.changed(self, what)
