from Components.Converter.Converter import Converter
from Tools.Directories import fileExists, SCOPE_SKIN_IMAGE, resolveFilename
from enigma import iServiceInformation, iPlayableService, iPlayableServicePtr
from Components.Element import cached
from Plugins.Extensions.LcdDigital.xmltools import *
from Components.config import config

import os

class TestLcdDigital(Converter, object):
#	searchPaths = ['/usr/share/enigma2/%s/',
#				'/media/cf/%s/',
#				'/media/usb/%s/']
				
	def __init__(self, type):
		Converter.__init__(self, "")
		self.tag,self.path,cut = type.split(":")
		self.cut = cut == "cut"

		pfad = "/media/"
		dirs = os.listdir(pfad)
		dirs.sort()
		self.searchPaths = []
		self.searchPaths.append('/usr/share/enigma2/%s/')
		self.searchPaths.append('/data/%s/')
		for dir in dirs:
			p = pfad + dir
			if os.path.ismount(p):
				self.searchPaths.append(p + "/%s/")
		
	def GetLength(self):			
		len = LcdDigital.value #config.plugins.lcddigital.getValue()
		if (len == 0):
			len = 1000
 		return len

	@cached
	def getText(self):
		text = self.source.source.text
		if self.cut:
			text = text[0:self.GetLength()]
		print "Text2: " + text
		return text
			
		
	text = property(getText)

	def changed(self, what):
		Converter.changed(self, what)
		tag = self.source.LcdDigitalTag
		if ((self.tag == "logo") or (self.tag == "nologo")):
			if ((tag == "logo") and (self.calcVisibility())):
				tag = "nologo"
		bool = (self.tag == tag)
		for x in self.downstream_elements:
			x.visible = bool

	def calcVisibility(self):
		pngname = ""
		sname = self.source.source.text
		if pngname == "":
			pngname = self.findPicon(sname)
		return pngname == ""

	def findPicon(self, serviceName):
		for path in self.searchPaths:
			p = (path % self.path)
			p = p.encode("latin-1")
			pngname = p + serviceName + ".png"
			if fileExists(pngname):
				return pngname
		return ""
