from Components.Converter.Converter import Converter
from Tools.Directories import fileExists, SCOPE_SKIN_IMAGE, resolveFilename
from enigma import iServiceInformation, iPlayableService, iPlayableServicePtr
from Components.Element import cached
from Plugins.Extensions.LcdDigital.xmltools import *
from Components.config import config

import os

class TestLcdDigitalRef(Converter, object):
#	searchPaths = ['/usr/share/enigma2/%s/',
#				'/media/cf/%s/',
#				'/media/usb/%s/']
				
	def __init__(self, type):
		Converter.__init__(self, "")
		self.tag,self.path,cut = type.split(":")
		self.cut = cut == "cut"

		pfad = "/media/"
		dirs = os.listdir(pfad)
		dirs.sort()
		self.searchPaths = []
		self.searchPaths.append('/usr/share/enigma2/%s/')
		self.searchPaths.append('/data/%s/')
		for dir in dirs:
			p = pfad + dir
			if os.path.ismount(p):
				self.searchPaths.append(p + "/%s/")
		
	def GetLength(self):			
		len = LcdDigital.value #config.plugins.lcddigital.getValue()
		if (len == 0):
			len = 1000
 		return len

	@cached
	def getText(self):
		t1name = self.source.source.text
		t2name = t1name.split('|')
		tag = self.source.LcdDigitalTag
#		print "self.tag: " + self.tag
		text = ""
		if ((self.tag == "logo") or (self.tag == "nologo")):
			if ((tag == "logo") and (self.calcVisibility())):
				tag = "nologo"
		if tag == "logo":
			if len(t2name) == 2:
				t3name = t2name[1].replace(":","_")
				text = t3name[0:len(t3name)-1]
			else:
				text = t1name
		elif tag == "nologo":
			text = t2name[0]
		else:
			text = ""
		if self.cut:
			text = text[0:self.GetLength()]
		print "Tag" + "_" + tag + "_" + str(len(t2name)) + "/" + self.tag
		print "Text1: " + text
		return text
			
		
	text = property(getText)

	def changed(self, what):
		Converter.changed(self, what)
		tag = self.source.LcdDigitalTag
		if ((self.tag == "logo") or (self.tag == "nologo")):
			if ((tag == "logo") and (self.calcVisibility())):
				tag = "nologo"
		bool = (self.tag == tag)
		for x in self.downstream_elements:
			x.visible = bool

	def calcVisibility(self):
		sname = self.source.source.text
		pngname = ""
		if pngname == "":
			pngname = self.findPicon(sname)
		return pngname == ""

	def findPicon(self, serviceName):
		t1name = serviceName
		if (len(t1name) > 0):
			t2name = t1name.split('|')
			if len(t2name) == 2:
				t3name = t2name[1].replace(":","_")
				sname = t3name[0:len(t3name)-1]
			else:
				sname = t1name
			for path in self.searchPaths:
				p = (path % self.path)
				p = p.encode("latin-1")
				pngname = p + sname + ".png"
#				print "pngname:" + pngname
				if fileExists(pngname):
					return pngname
		return ""
