##
## Picon renderer by Gruffy .. some speedups by Ghost
##
from Renderer import Renderer
from enigma import ePixmap
from Tools.Directories import fileExists, SCOPE_SKIN_IMAGE, SCOPE_CURRENT_SKIN, resolveFilename

import os

class LcdPicon(Renderer):
#	searchPaths = ('/usr/share/enigma2/%s/',
#				'/media/cf/%s/',
#				'/media/usb/%s/')

	def ReadLine(self,f):
		s = f.readline()
		if (s):
			s = str(buffer(s,0,len(s)-1))
		return s
			
	def GetMountPoints(self):
		self.searchPaths = []
		self.searchPaths.append('/usr/share/enigma2/%s/')
		self.searchPaths.append('/data/%s/')
		file = open("/proc/mounts")
		s = self.ReadLine(file)
		while (s):
			for p in s.split(" "):
				if (p.find("/media/") == 0):
					if p !="/media/ba":
						self.searchPaths.append(p + "/%s/")
			s = self.ReadLine(file)
		file.close()
		
	def __init__(self):
		Renderer.__init__(self)
		self.path = "picon"
		self.nameCache = { }
		self.pngname = ""
		self.GetMountPoints()
		
	def applySkin(self, desktop, parent):
		attribs = [ ]
		for (attrib, value) in self.skinAttributes:
			if attrib == "path":
				self.path = value
			else:
				attribs.append((attrib,value))
		self.skinAttributes = attribs
		return Renderer.applySkin(self, desktop, parent)

	GUI_WIDGET = ePixmap

	def changed(self, what):
		if self.instance:
			pngname = ""
			if what[0] != self.CHANGED_CLEAR:
				sname = self.source.text
				# strip all after last :
				pos = sname.rfind(':')
				if pos != -1:
					sname = sname[:pos].rstrip(':').replace(':','_')
				pngname = self.nameCache.get(sname, "")
				if pngname == "":
					pngname = self.findPicon(sname)
					if pngname != "":
						self.nameCache[sname] = pngname
			if pngname == "": # no picon for service found
				pngname = self.nameCache.get("default", "")
				if pngname == "": # no default yet in cache..
					pngname = self.findPicon("picon_default")
					#if pngname == "":
					#	tmp = resolveFilename(SCOPE_CURRENT_SKIN, "picon_default.png")
					#	if fileExists(tmp):
					#		pngname = tmp
					#	else:
					#		pngname = resolveFilename(SCOPE_SKIN_IMAGE, "skin_default/picon_default.png")
					self.nameCache["default"] = pngname
			if self.pngname != pngname:
				if pngname != "":
#					print "Set:" + pngname
					self.instance.setPixmapFromFile(pngname)
					self.pngname = pngname

	def findPicon(self, serviceName):
		for path in self.searchPaths:
			pngname = (path % self.path) + serviceName + ".png"
#			print pngname
			if fileExists(pngname):
#				print "Exit"
				return pngname
		return ""
