# coding=ISO-8859-1
from enigma import *
from Plugins.Plugin import PluginDescriptor
from Plugins.Extensions.LcdDigital.Setup import LcdDigitalSetup
from Plugins.Extensions.LcdDigital.xmltools import *
from skin import *
from Components.config import config,ConfigElement

from Tools.Directories import resolveFilename, SCOPE_SKIN, SCOPE_SKIN_IMAGE, SCOPE_FONTS

import gettext
try:
	cat = gettext.translation('lang', '/usr/lib/enigma2/python/Plugins/Extensions/LcdDigital/po', [config.osd.language.getText()])
	_ = cat.gettext
except IOError:
	pass

def readServiceList():	
	service_types = '1:7:1:0:0:0:0:0:0:0:(type == 1) || (type == 17) || (type == 195) || (type == 25) || (type == 134)'
	refstr = '%s ORDER BY name'%(service_types)
	ref = eServiceReference(refstr)
	serviceHandler = eServiceCenter.getInstance()
	list = serviceHandler.list(ref)
	service = None
	LcdDigital.ServiceList = {}
	if list is not None:
		while 1:
			s = list.getNext()
			if s.valid():
				name = None
				transponder_info = None
				if s is not None:
					info = serviceHandler.info(s)
					if info is not None:
						name = info.getName(s)
						transponder_info = info.getInfoObject(s, iServiceInformation.sTransponderData)
				if name is not None and  transponder_info is not None:
					lname = name.replace('\xc2\x86', '').replace('\xc2\x87', '')
#					tname = lname.lower().replace(" ","").replace("-","").replace(".","")
#					type = transponder_info.get("tuner_type", "None")
#					if type == "DVB-S":
#						tname += "_" + str(transponder_info["orbital_position"])
##					LogDebug(self.setup,"INFO","Init mod. Channel",str(tname))
##					f.write(s.toString());
##					f.write("|");
##					f.write(tname);
##					f.write("\n");
#					try:
#						uname = unicode(lname,"utf-8")
#						name = uname.encode("ISO-8859-1")
#						item = temp.createElement("service")
#						item.setAttribute("ref", ConvertToUtf8(s.toString()))
#						item.setAttribute("channel", ConvertToUtf8(name))
#						#item.setAttribute("provider", ConvertToUtf8(provider))
#						rec.appendChild(item);
#					except:
#						self.ServiceError = True
					
					print "Liste: " + lname + "|" + s.toString()	
					LcdDigital.ServiceList[lname] = s.toString()
			else:
				break
	
def start():
	Update()
#	filename = SKINDIR + "/" + SETUP
#	if not(os.path.isfile(filename)):
	CheckSkins()
	on = GetSetupAttrib(SETUP,"plugin")
	if (on == ON):
		if True:
#		try:
			readServiceList()
			skin = GetSetupAttrib(SETUP,"skin")
			Size = int(GetSetupAttrib(SETUP,"size"))
			LogoOn = GetSetupAttrib(SETUP,"logoinfobox") == ON
#			config.plugins.lcddigital = ConfigElement()
#			config.plugins.lcddigital.default = 0
#			config.plugins.lcddigital.setValue(int(GetSetupAttrib(SETUP,"len")))
			
			LcdDigital.value = int(GetSetupAttrib(SETUP,"len"))
			
			screens = {}
			screenson = {}
			fonts = {}
			ReadSkins(skin,screens,fonts)
			ReadScreensOn(skin,screens,screenson)

			filename = "nmsbd.ttf"
			name = "RegularDIGI"
			scale = Size
			is_replacement = False
			addFont(resolveFilename(SCOPE_FONTS, filename), name, scale, is_replacement)

			for  name,(file,scale,is_replacement) in fonts.items():
				addFont(resolveFilename(SCOPE_FONTS, file), name, scale, is_replacement)

			if LogoOn:
				for (path, skin) in dom_skins:
					for screen in skin.findall("screen"):
						#if (screen.attrib["name"] == "InfoBar"):
						if True:
							for widget in screen.findall("widget"):
								try:
									if ((widget.attrib["source"] == "session.CurrentService") and (widget.attrib["render"] == "Picon")):
										print screen.attrib["name"]
										for convert in widget.findall("convert"):
											if (convert.attrib["type"] == "ServiceName"):
												widget.attrib["render"] = "LcdPicon"
												widget.attrib["path"] = "LcdDigital/LcdDigitalPicons/Picons"
												convert.text="Name"
								except KeyError:
									pass

			for screen,on in screenson.items():
				if (on == ON):
					#filename = resolveFilename(SCOPE_SKIN, screen + ".xml")
					#mpath = path.dirname(filename) + "/"
					dom_skins.insert(0,(None,MakeDoc(screens[screen])))

#		except:
#			print "EXCEPTION: LcdDigital (CheckSkins)"
#			CheckSkins()

def autostart(reason, **kwargs):
	if reason == 0:
		start()
	
def main(session, **kwargs):
	session.open(LcdDigitalSetup)
	
def Plugins(**kwargs):
	if (os.path.isdir("/usr/lib/enigma2/python/Plugins/Extensions/AladinsPluginContainer")):
		return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART], fnc = autostart)]
	else:
		return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART], fnc = autostart),PluginDescriptor(name=_("LCD-Digital-Skin"), description=_("Setup"), where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main, icon="plugin.png")]
